"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const BaseInteractionHandler_1 = require("../../InteractionsAPI/BaseInteractionHandler");
const CommandInteractionManager_1 = require("./CommandInteractionManager");
/**
 * The CommandInteraction handler
 * @class
 * @abstract
 */
class CommandInteractionHandler extends BaseInteractionHandler_1.default {
    /**
     * Handler for a Command Interaction. Will auto register with the manager supplied.
     * @constructor
     * @method
     * @param {CommandInteractionHandlerOptions} commandOptions The command options to supply
     * @param {CommandInteractionManager} manager The CommandInteractionManager
     * @public
     */
    constructor(commandOptions, manager) {
        super(commandOptions);
        this.commandOptions = commandOptions;
        if (!(manager instanceof CommandInteractionManager_1.default))
            throw new TypeError(`The manager must be an instance of a CommandInteractionManager`);
        this.commandOptions = Object.assign(Object.assign({}, commandOptions), { type: 'CHAT_INPUT' });
        if (manager)
            manager.registerInteractionHandler(commandOptions.name, this);
    }
}
exports.default = CommandInteractionHandler;
