import { Client, Interaction } from 'discord.js';
import BaseInteractionHandler from './BaseInteractionHandler';
import BaseInteractionManager from './BaseInteractionManager';
/**
 * The Interaction Event handler, handles Interaction events
 */
export default class InteractionEventHandler {
    /**
     * The managers of the Event handler
     * @private
     */
    private managers;
    /**
     * @constructor
     * @public
     */
    constructor();
    /**
     * Handles the interaction event
     * @param client The Discord.js Client
     * @public
     */
    hook(client: Client): void;
    /**
     * Pass in new handlers to use
     * @param handlers The handlers to use
     * @typedef {BaseInteractionManager|Array}
     * @public
     */
    use(handler: BaseInteractionManager<Interaction, BaseInteractionHandler>): void;
    use(handlers: BaseInteractionManager<Interaction, BaseInteractionHandler>[]): void;
    /**
     * Internal function to handle interactions
     * @param interaction The interaction to handle|
     * @private
     */
    private _handleInteraction;
}
